#if !defined(AFX_BUTTONTEXTURE_H__4F10FDCD_EF77_423F_8223_011704DFFED2__INCLUDED_)
#define AFX_BUTTONTEXTURE_H__4F10FDCD_EF77_423F_8223_011704DFFED2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef vector<COLORREF>::iterator ColorRefIterator;

struct BUTTONSETTINGS
{
	int leftEdge;
	int topEdge;
	int rightEdge;
	int bottomEdge;

	int mode;

	int button_saturation;
	int button_hueIntensity;
	COLORREF button_hueColor;

	int Alpha;
};

class ButtonTexture  
{
public:
	ButtonTexture(const string &name);
	virtual ~ButtonTexture();

	void configure(const string &name);
	void apply(HDC hDC, int x, int y, int width, int height, int buttonType);

	/*bool has_normalAlphaMap;
	bool has_activeAlphaMap;
	bool has_minimizedAlphaMap;
	bool has_flashingAlphaMap;*/

	int normalAlpha;
	int activeAlpha;
	int minimizedAlpha;
	int flashingAlpha;
	int hoverAlpha;
	int groupAlpha;

private:

	void subconfigure(string type, BUTTONSETTINGS &workSettings, BUTTONSETTINGS &defaultSettings);

	void parseCFG(string cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor);
	void parseGradientCFG(string cfg, int imageType);
	void solidGradientPaint(HDC destHDC, vector<COLORREF> workGradient, RECT r, bool vertical);
	void paintEffects(HDC destHDC, int width, int height, int button_saturation, int button_hueIntensity, COLORREF button_hueColor );
	//void PrepareAlphaChannel(HBITMAP &bmp);

	vector<COLORREF> NormalGradient;
	vector<COLORREF> ActiveGradient;
	vector<COLORREF> MinimizedGradient;
	vector<COLORREF> FlashingGradient;

	vector<COLORREF> HoverGradient;
	vector<COLORREF> GroupGradient;

	HDC memoryNormalDC;
	HBITMAP memoryNormalBitmap;

	HDC memoryActiveDC;
	HBITMAP memoryActiveBitmap;

	HDC memoryMinimizedDC;
	HBITMAP memoryMinimizedBitmap;

	HDC memoryFlashingDC;
	HBITMAP memoryFlashingBitmap;

	HDC memoryHoverDC;
	HBITMAP memoryHoverBitmap;

	HDC memoryGroupDC;
	HBITMAP memoryGroupBitmap;

	int imageNormalHeight;
	int imageNormalWidth;

	int imageActiveHeight;
	int imageActiveWidth;

	int imageMinimizedHeight;
	int imageMinimizedWidth;

	int imageFlashingHeight;
	int imageFlashingWidth;

	int imageHoverHeight;
	int imageHoverWidth;

	int imageGroupHeight;
	int imageGroupWidth;

	BUTTONSETTINGS defaultbutton;;
	BUTTONSETTINGS normal;
	BUTTONSETTINGS active;
	BUTTONSETTINGS minimized;
	BUTTONSETTINGS flashing;
	BUTTONSETTINGS hover;	
	BUTTONSETTINGS group;

	string defaultsolidcolors;
	int defaultbevelSize;
	string defaultgradientColor;
	bool defaultverticalGradient;

	bool usenormalSolidColors;
	string normalsolidcolors;
	bool normalverticalGradient;
	int normalbevelSize;
	string normalgradientColor;
	COLORREF normalbackgroundColor;
	COLORREF normaldarkBevelColor;
	COLORREF normallightBevelColor;

	bool useactiveSolidColors;
	bool activeverticalGradient;
	int activebevelSize;
	COLORREF activebackgroundColor;
	COLORREF activedarkBevelColor;
	COLORREF activelightBevelColor;

	bool useminimizedSolidColors;
	bool minimizedverticalGradient;
	int minimizedbevelSize;
	COLORREF minimizedbackgroundColor;
	COLORREF minimizeddarkBevelColor;
	COLORREF minimizedlightBevelColor;

	bool useflashingSolidColors;
	bool flashingverticalGradient;
	int flashingbevelSize;
	COLORREF flashingbackgroundColor;
	COLORREF flashingdarkBevelColor;
	COLORREF flashinglightBevelColor;

	bool usehoverSolidColors;
	bool hoververticalGradient;
	int hoverbevelSize;
	COLORREF hoverbackgroundColor;
	COLORREF hoverdarkBevelColor;
	COLORREF hoverlightBevelColor;

	bool usegroupSolidColors;
	bool groupverticalGradient;
	int groupbevelSize;
	COLORREF groupbackgroundColor;
	COLORREF groupdarkBevelColor;
	COLORREF grouplightBevelColor;
};

#endif // !defined(AFX_BUTTONTEXTURE_H__4F10FDCD_EF77_423F_8223_011704DFFED2__INCLUDED_)
