#if !defined(AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_)
#define AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef list<HWND> hWndGroupList;
typedef list<HWND>::iterator hWndGroupListIterator;
 
class TaskbarButton  
{
	friend class Taskbar;

public:

	TaskbarButton( Taskbar *actualtaskbar, HWND hWnd );
	virtual ~TaskbarButton();

private:

	//Grouping
	//--------------------------------------------------
	hWndGroupList hwndgrouplist;

	void AddToGroup( HWND add_hTask )
	{
		hwndgrouplist.insert(hwndgrouplist.end(), add_hTask);
	}

	BOOL SearchInGroup( HWND search_hTask )
	{
		for(hWndGroupListIterator hglit = hwndgrouplist.begin(); hglit != hwndgrouplist.end(); hglit++)
		{
			if ( *hglit == search_hTask )
				return TRUE;
		}
		return FALSE;
	}

	BOOL RemoveFromGroup( HWND remove_hTask )
	{
		for(hWndGroupListIterator hglit = hwndgrouplist.begin(); hglit != hwndgrouplist.end(); hglit++)
		{
			if ( (*hglit) == remove_hTask )
			{
				delete (*hglit);
				hwndgrouplist.erase( hglit );

				hButtonTask = (*hwndgrouplist.begin());

				return true;
			}
		}
		return false;
	}
	//--------------------------------------------------

	Taskbar *taskbar;

	HWND hButtonTask;
	string classname;
	string caption;
	string tooltip;

	int buttonx;
	int buttony;
	int buttonwidth;
	int buttonheight;

	void setButtonLayout( int x, int y, int width, int height );
	BOOL HasPoint( int xP, int yP );

	BOOL onUpdate(bool needRedraw = false);

	string GetWindowCaption( HWND check_hTask = NULL );

	bool useHover;
	int position;

	int currentState;
	int getCurrentState();

	bool flashNow; //Start/Stop Flashing every Second

	void SetFlashing(bool flash)
	{
		flashNow = flash;
	}

	BOOL GetFlashing() const
	{
		return flashNow;
	}

	void onButtonClick( int x, int y, int action );	
	void Select();
	void GroupMenu();
	void Menu();

	void onPaint( HDC hDC );

protected:

	HICON icon;
	bool refreshIcon;

};

#endif // !defined(AFX_TASKBARBUTTON_H__80A0FBD2_FB89_4557_822D_0E5BB681EC99__INCLUDED_)
